searchData={"items":[{"type":"module","title":"LightningCSS","doc":"[![Lightning CSS](https://github.com/tuist/lightning_css/actions/workflows/lightningcss.yml/badge.svg)](https://github.com/tuist/lightning_css/actions/workflows/lightningcss.yml)\n[![Module Version](https://img.shields.io/hexpm/v/mimic.svg)](https://hex.pm/packages/lightning_css)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/lightning_css/)\n[![Total Download](https://img.shields.io/hexpm/dt/lightning_css.svg)](https://hex.pm/packages/lightning_css)\n[![License](https://img.shields.io/hexpm/l/lightning_css.svg)](https://github.com/tuist/lightning_css/blob/master/LICENSE)\n[![Last Updated](https://img.shields.io/github/last-commit/tuist/lightning_css.svg)](https://github.com/tuist/lightning_css/commits/master)\n\n`lightning_css` is an Elixir package to integrate [Lightning CSS](https://lightningcss.dev/) into an Elixir project.","ref":"LightningCSS.html"},{"type":"module","title":"Installation - LightningCSS","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `lightning_css` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:lightning_css, \"~> 0.4.0\"}\n  ]\nend\n```","ref":"LightningCSS.html#module-installation"},{"type":"module","title":"Usage - LightningCSS","doc":"After installing the package, you'll have to configure it in your project:\n\n```elixir\n# config/config.exs\nconfig :lightning_css,\n  version: \"1.22.1\",\n  default: [\n    args: ~w(assets/css/app.css --bundle --output-file=priv/static/styles/bundle.css),\n    watch_files: \"assets/css/**/*.css\",\n    cd: Path.expand(\"..\", __DIR__),\n    env: %{\"NODE_PATH\" => Path.expand(\"../deps\", __DIR__)}\n  ]\n```","ref":"LightningCSS.html#module-usage"},{"type":"module","title":"Configuration options - LightningCSS","doc":"- **version:** Indicates the version that the package will download and use. When absent, it defaults to the value of `@latest_version` at [`lib/lightning_css.ex`](./lib/lightning_css.ex).\n- **profiles:** Additional keys in the configuration keyword list represent profiles. Profiles are a combination of attributes the Lightning CSS can be executed with. You can indicate the profile to use when invoking the Mix task by using the `--profile` flag, for example `mix lightning_css --profile dev`. A profile is represented by a keyword list with the following attributes:\n  - **args:** An list of strings representing the arguments that will be passed to the Lightning CSS executable.\n  - **watch_files (optional):** A glob pattern that will be used when Lightning CSS is invoked with `--watch` to match the file changes against it.\n  - **cd (optional):** The directory from where Lightning CSS is executed. When absent, it defaults to the project's root directory.\n  - **env (optional):** A set of environment variables to make available to the Lightning CSS process.","ref":"LightningCSS.html#module-configuration-options"},{"type":"module","title":"Phoenix - LightningCSS","doc":"If you are using the Phoenix framework, we recommend doing an integration similar to the one Phoenix proposes by default for Tailwind and ESBuild.\n\nAfter adding the dependency and configuring it as described above with at least one profile, adjust your app's endpoint configuration to add a new watcher:\n\n```elixir\nconfig :my_app, MyAppWeb.Endpoint,\n  # ...other attributes\n  watchers: [\n    # :default is the name of the profile. Update it to match yours.\n    css: {LightningCSS, :install_and_run, [:default, ~w(), [watch: true]]}\n  ]\n```\n\nThen update the `aliases` of your project's `mix.exs` file:\n\n```elixir\ndefp aliases do\n  [\n    # ...other aliases\n    \"assets.setup\": [\n      # ...other assets.setup tasks\n      \"lightning_css.install --if-missing\"\n    ],\n    \"assets.build\": [\n      # ...other assets.build tasks\n      \"lightning_css default\",\n    ],\n    \"assets.deploy\": [\n      # ...other deploy tasks\n      \"lightning_css default\",\n    ]\n  ]\nend\n```","ref":"LightningCSS.html#module-phoenix"},{"type":"function","title":"LightningCSS.install_and_run/3","doc":"Installs, if not available, and then runs `lightning_css`.\n\nReturns the same as `run/2`.","ref":"LightningCSS.html#install_and_run/3"},{"type":"function","title":"LightningCSS.run/3","doc":"Runs the given command with `args`.\n\nThe given args will be appended to the configured args.\nThe task output will be streamed directly to stdio. It\nreturns the status of the underlying call.","ref":"LightningCSS.html#run/3"},{"type":"function","title":"LightningCSS.start/2","doc":"","ref":"LightningCSS.html#start/2"},{"type":"module","title":"LightningCSS.Architectures","doc":"This module groups functions to read the architecture from the environment in which the code is running.","ref":"LightningCSS.Architectures.html"},{"type":"function","title":"LightningCSS.Architectures.target/0","doc":"","ref":"LightningCSS.Architectures.html#target/0"},{"type":"module","title":"LightningCSS.Configuration","doc":"This module groups functions to read the configuration from the application environment.","ref":"LightningCSS.Configuration.html"},{"type":"function","title":"LightningCSS.Configuration.config_for!/1","doc":"Returns the configuration for the given profile.\n\nReturns nil if the profile does not exist.","ref":"LightningCSS.Configuration.html#config_for!/1"},{"type":"module","title":"LightningCSS.Installer","doc":"This module encapsulates the installation logic that is responsible for pulling the right binary (version and architecture)\nfrom the npm registry.","ref":"LightningCSS.Installer.html"},{"type":"function","title":"LightningCSS.Installer.install/0","doc":"Installs lightning_css with `configured_version/0`.","ref":"LightningCSS.Installer.html#install/0"},{"type":"module","title":"LightningCSS.Paths","doc":"This module groups utilities to read the paths from the application environment.","ref":"LightningCSS.Paths.html"},{"type":"function","title":"LightningCSS.Paths.bin/0","doc":"Returns the path to the executable.\n\nThe executable may not be available if it was not yet installed.","ref":"LightningCSS.Paths.html#bin/0"},{"type":"function","title":"LightningCSS.Paths.cacertfile/0","doc":"","ref":"LightningCSS.Paths.html#cacertfile/0"},{"type":"module","title":"LightningCSS.Versions","doc":"This module groups functions to read default and remote versions of Lightning CSS.","ref":"LightningCSS.Versions.html"},{"type":"function","title":"LightningCSS.Versions.bin/0","doc":"Returns the version of the lightning_css executable.\n\nReturns `{:ok, version_string}` on success or `:error` when the executable\nis not available.","ref":"LightningCSS.Versions.html#bin/0"},{"type":"function","title":"LightningCSS.Versions.configured/0","doc":"Returns the version of Lightning CSS that this package should use.","ref":"LightningCSS.Versions.html#configured/0"},{"type":"function","title":"LightningCSS.Versions.latest/0","doc":"Returns the most recent Lightning CSS version known by this package.","ref":"LightningCSS.Versions.html#latest/0"},{"type":"function","title":"LightningCSS.Versions.to_use/0","doc":"Returns the configured version falling back to the latest if there's no version configured.","ref":"LightningCSS.Versions.html#to_use/0"},{"type":"task","title":"mix lightning_css","doc":"Runs lightning_css with the given profile and args.\n\n```bash\n$ mix lightning_css --runtime-config dev\n```\n\nThe task will install lightning_css if it hasn't been installed previously\nvia the `mix lightning_css.install` task.","ref":"Mix.Tasks.LightningCss.html"},{"type":"task","title":"Options - mix lightning_css","doc":"* `--runtime-config` - load the runtime configuration\n    before executing command\n    * `--watch` - watches for file changes and re-runs Lightning CSS when any of the matched files changes.","ref":"Mix.Tasks.LightningCss.html#module-options"},{"type":"task","title":"mix lightning_css.install","doc":"Installs lightning_css under `_build`.\n\n```bash\n$ mix lightning_css.install\n$ mix lightning_css.install --if-missing\n```\n\nBy default, it installs 1.22.0 but you\ncan configure it in your config files, such as:\n\n    config :lightning_css, :version, \"1.22.0\"","ref":"Mix.Tasks.LightningCss.Install.html"},{"type":"task","title":"Options - mix lightning_css.install","doc":"* `--runtime-config` - load the runtime configuration\n      before executing command\n\n    * `--if-missing` - install only if the given version\n      does not exist","ref":"Mix.Tasks.LightningCss.Install.html#module-options"},{"type":"extras","title":"License","doc":"MIT License\n\nCopyright (c) 2024 Tuist\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"},{"type":"extras","title":"Overview","doc":"# `lightning_css`\n\n<!-- MDOC !-->\n\n[![Lightning CSS](https://github.com/tuist/lightning_css/actions/workflows/lightningcss.yml/badge.svg)](https://github.com/tuist/lightning_css/actions/workflows/lightningcss.yml)\n[![Module Version](https://img.shields.io/hexpm/v/mimic.svg)](https://hex.pm/packages/lightning_css)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/lightning_css/)\n[![Total Download](https://img.shields.io/hexpm/dt/lightning_css.svg)](https://hex.pm/packages/lightning_css)\n[![License](https://img.shields.io/hexpm/l/lightning_css.svg)](https://github.com/tuist/lightning_css/blob/master/LICENSE)\n[![Last Updated](https://img.shields.io/github/last-commit/tuist/lightning_css.svg)](https://github.com/tuist/lightning_css/commits/master)\n\n`lightning_css` is an Elixir package to integrate [Lightning CSS](https://lightningcss.dev/) into an Elixir project.","ref":"readme.html"},{"type":"extras","title":"Installation - Overview","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `lightning_css` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:lightning_css, \"~> 0.4.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Overview","doc":"After installing the package, you'll have to configure it in your project:\n\n```elixir\n# config/config.exs\nconfig :lightning_css,\n  version: \"1.22.1\",\n  default: [\n    args: ~w(assets/css/app.css --bundle --output-file=priv/static/styles/bundle.css),\n    watch_files: \"assets/css/**/*.css\",\n    cd: Path.expand(\"..\", __DIR__),\n    env: %{\"NODE_PATH\" => Path.expand(\"../deps\", __DIR__)}\n  ]\n```","ref":"readme.html#usage"},{"type":"extras","title":"Configuration options - Overview","doc":"- **version:** Indicates the version that the package will download and use. When absent, it defaults to the value of `@latest_version` at [`lib/lightning_css.ex`](./lib/lightning_css.ex).\n- **profiles:** Additional keys in the configuration keyword list represent profiles. Profiles are a combination of attributes the Lightning CSS can be executed with. You can indicate the profile to use when invoking the Mix task by using the `--profile` flag, for example `mix lightning_css --profile dev`. A profile is represented by a keyword list with the following attributes:\n  - **args:** An list of strings representing the arguments that will be passed to the Lightning CSS executable.\n  - **watch_files (optional):** A glob pattern that will be used when Lightning CSS is invoked with `--watch` to match the file changes against it.\n  - **cd (optional):** The directory from where Lightning CSS is executed. When absent, it defaults to the project's root directory.\n  - **env (optional):** A set of environment variables to make available to the Lightning CSS process.","ref":"readme.html#configuration-options"},{"type":"extras","title":"Phoenix - Overview","doc":"If you are using the Phoenix framework, we recommend doing an integration similar to the one Phoenix proposes by default for Tailwind and ESBuild.\n\nAfter adding the dependency and configuring it as described above with at least one profile, adjust your app's endpoint configuration to add a new watcher:\n\n```elixir\nconfig :my_app, MyAppWeb.Endpoint,\n  # ...other attributes\n  watchers: [\n    # :default is the name of the profile. Update it to match yours.\n    css: {LightningCSS, :install_and_run, [:default, ~w(), [watch: true]]}\n  ]\n```\n\nThen update the `aliases` of your project's `mix.exs` file:\n\n```elixir\ndefp aliases do\n  [\n    # ...other aliases\n    \"assets.setup\": [\n      # ...other assets.setup tasks\n      \"lightning_css.install --if-missing\"\n    ],\n    \"assets.build\": [\n      # ...other assets.build tasks\n      \"lightning_css default\",\n    ],\n    \"assets.deploy\": [\n      # ...other deploy tasks\n      \"lightning_css default\",\n    ]\n  ]\nend\n```","ref":"readme.html#phoenix"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.36.1"}}